var OrderStatus = {"order":"order", "pay":"pay", "cancel":"cancel"};

if (!String.prototype.padStart) {
    String.prototype.padStart = function padStart(targetLength,padString) {
        targetLength = targetLength>>0; //truncate if number or convert non-number to 0;
        padString = String((typeof padString !== 'undefined' ? padString : ' '));
        if (this.length > targetLength) {
            return String(this);
        }
        else {
            targetLength = targetLength-this.length;
            if (targetLength > padString.length) {
                padString += padString.repeat(targetLength/padString.length); //append to original to ensure we are longer than needed
            }
            return padString.slice(0,targetLength) + String(this);
        }
    };
}

function getDate(format){
    
    let date = new Date();
    let year = date.getFullYear();
    let month = String(date.getMonth() + 1).padStart(2,"0");
    let day = String(date.getDate()).padStart(2,"0");
    let hour = String(date.getHours()).padStart(2,"0");
    let min = String(date.getMinutes()).padStart(2,"0");
    let sec = String(date.getSeconds()).padStart(2,"0");

    let outDate = "";

    switch (format)
    {
        case 1:
            outDate = `${year}${month}${day}${hour}${min}${sec}`;
        break;

        case 2:
            outDate = `${year}-${month}-${day} ${hour}:${min}:${sec}`;
        break;

        case 3:
            outDate = `${year}.${month}.${day} ${hour}:${min}:${sec}`;
        break;

        case 4:
            outDate = `${year}년 ${month}월 ${day}일 ${hour}시 ${min}분 ${sec}초`;
        break;

        case 5:
            outDate = `${year}${month}${day}${hour}${min}`;
        break;



        case 11:
            outDate = `${year}${month}${day}`;
        break;

        case 12:
            outDate = `${year}-${month}-${day}`;
        break;

        case 13:
            outDate = `${year}.${month}.${day}`;
        break;

        case 14:
            outDate = `${year}년 ${month}월 ${day}일`;
        break;



        case 21:
            outDate = `${hour}${min}${sec}`;
        break;

        case 22:
            outDate = `${hour}:${min}:${sec}`;
        break;

        case 23:
            outDate = `${hour}시${min}분${sec}초`;
        break;

        case 24:
            outDate = `${hour}${min}`;
        break;

        

        default:
            outDate = `${year}-${month}-${day} ${hour}:${min}:${sec}`;
    }

    return outDate;

}

function getWeekNo(){
    
    return new Date().getDay();
}

function getWeekLabel(getWeekNo){
    
    let Week = new Array("일", "월", "화", "수", "목", "금", "토"); 
    return Week[getWeekNo];
}

function toast(title, msg, icon=false, dpTime=2000){
	
    let tHtml = '<div class="toast';
    if(icon == true) tHtml += ' warning';
    tHtml += '">';
    tHtml += '<div class="title">' + (title != null ? title : "알림") + '</div>';
    tHtml += '<div class="content">' + msg.replace(/\n/g, "<br>") + '</div></div>';

	let $newToast = $(tHtml);

	$("#toast").append($newToast);

    setTimeout(function(){
        
        $newToast.attr("remove",true);

	}, dpTime - 500);
	
	setTimeout(function(){
        
        $newToast.remove();

	}, dpTime);
	
}

function noti(type="alert", msg, sync=true){

    let tHtml = '';
    tHtml += '<div class="cofirm_popup" type="'+type+'" sync="'+sync+'">';
	tHtml += '	<div class="wrap_container">';
	tHtml += '		<div class="wrap_content">';
    tHtml +=            msg.replace(/\n/g, "<br>");
	tHtml += '		</div>';
	tHtml += '		<div class="btn_section">';
	tHtml += '			<div class="ok_btn btn btn_large touch">확인<span class="countdown">10</span></div>';
	tHtml += '			<div class="cancel_btn btn btn_large btn_w touch">취소</div>';
	tHtml += '		</div>';
	tHtml += '	</div>';
	tHtml += '</div>';

	let $newConfirm = $(tHtml);
    let $ok_btn = $newConfirm.find(".ok_btn");
    let $countdown = $newConfirm.find(".countdown");
    
	$("body").append($newConfirm);

    if(sync === false)
    {
        let timerCount = setInterval(function(){

            if(Number($countdown.text()) <= 0){
    
                $ok_btn.trigger("click");
                
                clearInterval(timerCount);
    
                return;
    
            }
    
            $countdown.text(Number($countdown.text()) - 1);
            
        }, 1000);
    }
	
}

/**
 *  alert, confirm 대용 팝업 메소드 정의 <br/>
 *  timer : 애니메이션 동작 속도 <br/>
 *  alert : 경고창 <br/>
 *  confirm : 확인창 <br/>
 *  open : 팝업 열기 <br/>
 *  close : 팝업 닫기 <br/>
 */ 
 var action_popup = {
    timer : 500,
    confirm : function(txt, callback){
        if(txt == null || txt.trim() == ""){
            console.warn("confirm message is empty.");
            return;
        }else if(callback == null || typeof callback != 'function'){
            console.warn("callback is null or not function.");
            return;
        }else{
            $(".type-confirm .btn_ok").on("click", function(){
                $(this).unbind("click");
                callback(true);
                action_popup.close(this);
            });
            this.open("type-confirm", txt);
        }
    },

    alert : function(txt){
        if(txt == null || txt.trim() == ""){
            console.warn("confirm message is empty.");
            return;
        }else{
            this.open("type-alert", txt);
        }
    },

    open : function(type, txt){
        var popup = $("."+type);
        popup.find(".menu_msg").text(txt);
        $("body").append("<div class='dimLayer'></div>");
        $(".dimLayer").css('height', $(document).height()).attr("target", type);
        popup.fadeIn(this.timer);
    },

    close : function(target){
        var modal = $(target).closest(".modal-section");
        var dimLayer;
        if(modal.hasClass("type-confirm")){
            dimLayer = $(".dimLayer[target=type-confirm]");
            $(".type-confirm .btn_ok").unbind("click");
        }else if(modal.hasClass("type-alert")){
            dimLayer = $(".dimLayer[target=type-alert]")
        }else{
            console.warn("close unknown target.")
            return;
        }
        modal.fadeOut(this.timer);
        setTimeout(function(){
            dimLayer != null ? dimLayer.remove() : "";
        }, this.timer);
    }
}

function ab_toast(msg){
	
    try
	{
        window.Android.AB_toast(msg);
	}
	catch(e){
        //
	}
	
}

function loading(){
	$("#loading_bar").attr("active", "true");
};

function loadDone(){
    setTimeout(function(){
        $("#loading_bar").attr("active", "false");
    }, 300);
};

function keyClick(ms){

	try
	{
        window.Android.AB_keyClick(ms);
	}
	catch(e){
        //
	}

};

function isJson(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

function jsonEscape(str) {
    return str.replace(/\n/g, "\\\\n").replace(/\r/g, "\\\\r").replace(/\t/g, "\\\\t");
}

function isNumber(str) {
    try {
        Number(str);
    } catch (e) {
        return false;
    }
    return true;
}

function toNumber(no, type="num"){

    no = no.toString().replace(/[^-0-9.]/g, "");
    if(type == "num") no = Number(no);
    return no;
	
}

function number_format(str){

	str += '';
    x = str.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? ',' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }
    return x1 + x2;
	
};

function phoneFomat(num){
	
	let formatNum = '';

    num = toNumber(num);
    
    /*
    if(num.length < 11){

        formatNum = num.replace(/([0-9]{0,3})([0-9]{0,3})([0-9]{0,4})/,"$1-$2-$3");

    }else{

        formatNum = num.replace(/([0-9]{3})([0-9]{4})([0-9]{4})/,"$1-$2-$3");

    }
    */
    
	if(num.length < 4){

        formatNum = num.replace(/(\d{3})/, '$1-');

    }else if(num.length >= 4 && num.length <= 6){

        formatNum = num.replace(/(\d{3})(\d+)/, '$1-$2');

    }else if(num.length > 6 && num.length < 11){

        formatNum = num.replace(/(\d{3})(\d{3})(\d{1,4})/, '$1-$2-$3');

    }else if(num.length >= 11){

        formatNum = num.replace(/(\d{3})(\d{4})(\d{4})/, '$1-$2-$3');

	}
    
    return formatNum;

}

function date_format(str){

    return str.substr(0, 8).replace(/(\d{4})(\d{2})(\d{2})/, '$1.$2.$3');

}

function apiRequest(url, data, asc=true){
    
	var res = $.ajax({
		type : "post",
		url : "api/" + url,
        data : data,
        async:asc,
        cache:false,
        //contentType:false,//파일전송
        processData:false,//파일전송
		beforeSend : function(xhr){
			if(localStorage["token"]){
				xhr.setRequestHeader("token", localStorage["token"]);
			}
		},
		error: function(x, e){
			if(x.status==0){
				alert("네트워크를 체크해주세요.");
			}else if(x.status==404){
				alert("요청하신 페이지를 찾을 수 없습니다.");
			}else if(x.status==500){
				alert("서버에러 발생하였습니다.");
			}else if(e=='parsererror'){
				alert("Error.\nParsing JSON Request failed.");
			}else if(e=='timeout'){
				alert("시간을 초과하였습니다.");
			}else {
				alert(x.responseText);
			}
		},
		success : function(data, textStatus, request){
			
			if(typeof data !='object')
			{
				toast(null, "서버수신 결과 DATA 형식이 잘 못 되었습니다.", true, 5000);
				return;
			}

			if(data.result == "1")
            {
                if(data.msg) toast(null, data.msg, true, 5000);
                localStorage["token"] = "";
                deviceAuthOpen();
            }
            else if(data.result == "2")
			{
                if(data.msg) noti("alert", data.msg, false);//toast(null, data.msg, true, 5000);
			}
			else if(data.result == "3")
			{
				if(data.msg) alert(data.msg);
			}
			
		},
		complete: function (){
			
			//loadDone();
			
		}
		
	})
	
	return res;
	
};

function scrollAdd(content_wrap){
	
    let scroll_wrap = content_wrap.find(".scroll_wrap");
    let search_frm = content_wrap.find(".search_frm");
    let page_cnt = search_frm.find("input[name='page_cnt']");
    let load_end = search_frm.find("input[name='load_end']");
	
	console.log("(" + scroll_wrap[0].scrollHeight + " - " + Math.floor(scroll_wrap.scrollTop()) + ") == " + scroll_wrap.outerHeight());

	if ((scroll_wrap[0].scrollHeight - Math.floor(scroll_wrap.scrollTop()) == scroll_wrap.outerHeight() || scroll_wrap[0].scrollHeight - Math.floor(scroll_wrap.scrollTop()) == scroll_wrap.outerHeight() + 1) && load_end.val() != "y"){

        console.log("작동");

        let frmId = document.getElementById(search_frm.attr("id"));
        
        frmId.enctype = search_frm.attr("enctype");
        
        let frmData = new FormData(frmId);

        DTns(search_frm.attr("action"), frmData).done(function(data, textStatus, request){
			
			if(data.result == "success"){
                
                list_add(content_wrap.attr("id"), data);
				
            }
    
        });
		
	}
	
};

$(function(){

    $("body").on("click", ".cofirm_popup .btn_section > .btn", function() {
    
        let $cofirm_popup = $(this).parents(".cofirm_popup");
        let dpTime = 1000;
    
        setTimeout(function(){
            
            $cofirm_popup.attr("remove",true);
    
        }, dpTime - 500);
        
        setTimeout(function(){
            
            $cofirm_popup.remove();
    
        }, dpTime);
    
    });

    $(".switch").on("click", ".switch_slid", function() {
    
        let btn_switch = $(this);
        let switchStat = btn_switch.attr("active");

        if(switchStat){
            btn_switch.removeAttr("active");
            //btn_switch.find("input[type='checkbox']").prop("checked", false);
            btn_switch.find("input").val("n").trigger("change");
        }
        else{
            btn_switch.attr("active", true);
            //btn_switch.find("input[type='checkbox']").prop("checked", true);
            btn_switch.find("input").val("y").trigger("change");
        }
        
    });

	$(".btn_submit").click(function() {
	
        $("form[id='" + $(this).attr("target") + "']").trigger("submit");
        
    })
    
    $("form[name='frm1']").submit(function() {
        
        let form = $(this);
        
        form.find("input[name='page_cnt']").val("");
        form.find("input[name='load_end']").val("");
        
        let frm_action = form1.attr("action");
        
        let frmData = new FormData(form[0]);
        //formData.set(name, value);
        let btn_back = $(this).parents(".content_wrap").find(".btn_back");
        
        DTns(frm_action, frmData)
            
            .done(function(data){
    
                if(data.result == "success"){
                    
    
                }
            
            });
        
        return false;
        
    })

    $("body").on("keyup", ".phone_format", function(){

        let formatNum = "";
    
        let num = $(this).val().replace(/[^0-9]/g, "");
    
        if(num.length < 4){
    
            formatNum = num.replace(/(\d{3})/, '$1-');
    
        }else if(num.length >= 4 && num.length <= 6){
    
            formatNum = num.replace(/(\d{3})(\d+)/, '$1-$2');
    
        }else if(num.length > 6 && num.length < 11){
    
            formatNum = num.replace(/(\d{3})(\d{3})(\d{1,4})/, '$1-$2-$3');
    
        }else if(num.length >= 11){
    
            formatNum = num.replace(/(\d{3})(\d{4})(\d{4})/, '$1-$2-$3');
    
        }
    
        $(this).val(formatNum);
    
    });
    
    //콤마찍기
    $("body").on("keyup", ".numberFormat", function(){
        
        if(isNaN($(this).val())){
            //return;
        }
        var pattern = /(-?[0-9]+)([0-9]{3})/;
        var num = $(this).val().replace(/\,/gi,"");
        while(pattern.test(num)) {
            num = num.replace(pattern,"$1,$2");
        }
        $(this).val(num);
    })
    
});

$(document).ajaxStart(function(){
    loading();
}).ajaxComplete(function(event,request, settings){
    loadDone();
});